//
// Created by bnozka on 02.02.2023.
//

#include<string>
#include<sstream>

#ifndef SWIFTMARK_BSIZE_H

constexpr size_t operator "" _kiB(unsigned long long int num) { return (size_t) ((1LL << 10)*num); }
constexpr size_t operator "" _MiB(unsigned long long int num) { return (size_t) ((1LL << 20)*num); }
constexpr size_t operator "" _GiB(unsigned long long int num) { return (size_t) ((1LL << 30)*num); }
constexpr size_t operator "" _kB(unsigned long long int num) { return (size_t) (1'000LL*num); }
constexpr size_t operator "" _MB(unsigned long long int num) { return (size_t) (1'000'000LL*num); }
constexpr size_t operator "" _GB(unsigned long long int num) { return (size_t) (1'000'000'000LL*num); }

std::string format(size_t size, bool si = true)
{
    std::ostringstream oss;
    oss << std::setprecision(3);
    if (size<(si ? 1_kB : 1_kiB))
        oss << size << "B ";
    else if (size<(si ? 1_MB : 1_MiB))
        oss << (size*1./(si ? 1_kB : 1_kiB)) << (si ? "kB " : "kiB ");
    else if (size<(si ? 1_GB : 1_GiB))
        oss << (size*1./(si ? 1_MB : 1_MiB)) << (si ? "MB " : "MiB ");
    else
        oss << (size*1./(si ? 1_GB : 1_GiB)) << (si ? "GB " : "GiB ");
    return oss.str();
}

#define SWIFTMARK_BSIZE_H

#endif //SWIFTMARK_BSIZE_H
